<template>
    <block type="feedback" v-bind="$attrs">
        <div class="container">
            <section-title 
                :title="this.title.title" 
                :text="this.title.text" 
                dots 
                :buttons="this.title.buttons"
            ></section-title>
            <form :action="linkAction" method="POST" class="feedback-form form">
                <div class="feedback-form__content">
                    <div class="form-field form-field--50 feedback-form__column">
                        <div class="form-field form-field--50">
                            <label>
                                {{ _trans('Имя') }}
                                <input type="text" name="feedback-name" :placeholder="_trans('Иван')" v-model="form.first_name" :class="{'input--error': this.errors.first_name}">
								<div class="input__error" v-if="this.errors.first_name">{{ this.errors.first_name }}</div>
                            </label>
                        </div>
                        <div class="form-field form-field--50">
                            <label>
                                {{ _trans('Фамилия') }}
                                <input type="text" name="feedback-surname" :placeholder="_trans('Иванов')" v-model="form.last_name" :class="{'input--error': this.errors.last_name}">
								<div class="input__error" v-if="this.errors.last_name">{{ this.errors.last_name }}</div>
                            </label>
                        </div>
                        <div class="form-field form-field--50">
                            <label>
                                {{ _trans('Email') }} 
                                <input type="text" name="feedback-email" placeholder="ivanov@mail.com" v-model="form.form_email" :class="{'input--error': this.errors.form_email}">
								<div class="input__error" v-if="this.errors.form_email">{{ this.errors.form_email }}</div>
                            </label>
                        </div>
                        <div class="form-field form-field--50">
                            <label>
                                {{ _trans('Номер телефона') }}
                                <input type="text" name="feedback-phone" id="input-phone" placeholder="+7 (999) 999-99-99" v-model="form.phone" :class="{'input--error': this.errors.phone}">
								<div class="input__error" v-if="this.errors.phone">{{ this.errors.phone }}</div>
							</label>
                        </div>
                    </div>
                    <div class="form-field form-field--50 feedback-form__textarea">
                        <label>
                            {{ _trans('Ваш отзыв') }}
                            <textarea name="feedback-message" :placeholder="_trans('Текст')" v-model="form.text" :class="{'input--error': this.errors.text}"></textarea>
							<div class="input__error" v-if="this.errors.text">{{ this.errors.text }}</div>
						</label>
                    </div>
                </div>
                <div class="feedback-form__footer">
                    <div class="form-field form-field--checkbox form-field--33">
                        <label class="checkbox">
                            <input class="visually-hidden" type="checkbox" name="callback-agree" v-model="form.checkbox" :class="{'input--error': this.errors.checkbox}">
                            <span class="checkbox-imitator"></span>
                            Я соглашаюсь на получение рекламной информации от нашей школы
                        </label>
						<div class="input__error" v-if="this.errors.checkbox">{{ this.errors.checkbox }}</div>
                    </div>
                    
                    <div class="form-field form-field--disclaimer form-field--25">
                        <p class="form__disclaimer">{{ _trans('Отправляя данную форму, вы соглашаетесь с') }} <a :href="linkDisclaimer">{{ _trans('политикой обработки данных') }}</a></p>
                    </div>

                    <div class="form-field form-field--submit form-field--25">
                        <button type="submit" class="button button--pink button--dots button--full" @click.prevent="send" :class="{'button--loading' : isLoading}">{{ _trans('Отправить отзыв') }}</button>
                    </div>
                </div>

				<div class="form__success" v-if="success">
					<div class="form__success__content">
						<svg version="1.1" id="Capa_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"
							viewBox="0 0 490.4 490.4" style="enable-background:new 0 0 490.4 490.4;" xml:space="preserve">
								<g>
									<g>
										<path d="M245.2,0C110,0,0,110,0,245.2s110,245.2,245.2,245.2s245.2-110,245.2-245.2S380.4,0,245.2,0z M245.2,465.9
											c-121.7,0-220.7-99-220.7-220.7s99-220.7,220.7-220.7s220.7,99,220.7,220.7S366.9,465.9,245.2,465.9z"/>
										<path d="M309.4,185.5l-94,93.5l-34.3-34.5c-4.8-4.8-12.5-4.8-17.3-0.1c-4.8,4.7-4.8,12.5-0.1,17.3l42.9,43.2
											c2.4,2.4,5.5,3.6,8.7,3.6c3.1,0,6.2-1.2,8.6-3.6l102.7-102.1c4.8-4.8,4.8-12.5,0.1-17.3C321.9,180.7,314.2,180.7,309.4,185.5z"/>
									</g>
								</g>
						</svg>
						<div class="form__success__title">{{ _trans('Заявка успешно отправлена') }}</div>
						<div class="form__success__text">{{ _trans('Мы свяжемся с вами в ближайшее время') }}</div>
					</div>
				</div>
				<input type="hidden" name="email" v-model="form.email">
            </form>
        </div>
    </block>
</template>

<script>
import IMask from 'imask';
import pickBy from "lodash-es/pickBy";
import size from "lodash-es/size";
import merge from "lodash-es/merge";

export default {
    props: {
        title: {
            type: Object,
            default: function () {
                return  {
                    title: 'Напишите отзыв',
                    text: 'Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt'
                }
            }
        },
        linkDisclaimer: {
            type: String,
            default: '#'
        },
        linkAction: {
            type: String,
            default: '#'
		},
		formData: {}
    },
    data() {
        return {
            isLoading: false,
            form: {
                first_name: null,
                last_name: null,
                phone: null,
				form_email: null,
				email: null,
                text: null,
                checkbox: false
            },
            errors: {

			},
			success: false
        }
    },
    mounted() {
        IMask(document.getElementById('input-phone'), {
            mask: '+{7} (000) 000-00-00'
        });
    },

    methods: {
        validate: function(){
            return {
                first_name  : !this.form.first_name ? "Укажите ваше имя"        : true,
                phone       : !this.form.phone      ? "Укажите телефон"         : true,
                form_email       : (() => {
                    if (!this.form.form_email) {
                        return "Укажите email";
                    } else {
                        var re = /(?:[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*|"(?:[\x01-\x08\x0b\x0c\x0e-\x1f\x21\x23-\x5b\x5d-\x7f]|\\[\x01-\x09\x0b\x0c\x0e-\x7f])*")@(?:(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?|\[(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?|[a-z0-9-]*[a-z0-9]:(?:[\x01-\x08\x0b\x0c\x0e-\x1f\x21-\x5a\x53-\x7f]|\\[\x01-\x09\x0b\x0c\x0e-\x7f])+)\])/;
                        if (!re.test(String(this.form.form_email).toLowerCase())) {
                            return "Email указан неверно";
                        } else {
                            return true;
                        }
                    }
                })(),
                text        : !this.form.text       ? "Укажите текст отзыва"    	: true,
				checkbox    : !this.form.checkbox	? "Подтвердите своё согласие"	: true,
				email		: this.form.email		? "Антиспам фильтр не пройден"	: true
            }
        },

        send: function(){
			this.errors = {};
			this.isLoading = true;

            var v = this.validate();
            this.errors = pickBy(v, function(value, key){return value !== true;});
            
            if (size(this.errors)) {
				this.isLoading = false;
                return false;
            }

			axios.post( this.linkAction, 
						merge(this.form, this.formData),
						{headers: {"Content-Type": "application/json"}}
					).then(response => {
                this.success = true;
            }).catch(error => {
				console.log(error);
			}).then(() => {
				this.isLoading = false;
			});
        }
    }
}
</script>